Plan to scale:
I would move parallel in two ways:

1. Reduce server response time. 
I would cache data that is used more often (popular customers and cuisines) in memcache.
I would store all data in MongoDB database as it allows to make a quick search
in large amounts of data and it's easy scalable.           

2. Increase number of servers as load increases.
I would start with 3 servers and a load balancer before them. 
And continuously increase number of servers as a load increases. 
This will allow system to be fail safe and adaptable to load.

# Cuisines Registry

## The story:

Cuisines Registry is an important part of Book-That-Table Inc. backend stack. It keeps in memory customer preferences for restaurant cuisines and is accessed by a bunch of components to register and retrieve data. 


The first iteration of this component was implemented by rather inexperienced developer and now may require some cleaning while new functionality is being added. But fortunately, according to his words: "Everything should work and please keep the test coverage as high as I did"


## Your tasks:
1. **[Important!]** Adhere to the boy scout rule. Leave your code better than you found it.
It is ok to change any code as long as the CuisinesRegistry interface remains unchanged.
2. Make is possible for customers to follow more than one cuisine (return multiple cuisines in de.quandoo.recruitment.registry.api.CuisinesRegistry#customerCuisines)
3. Implement de.quandoo.recruitment.registry.api.CuisinesRegistry#topCuisines - returning list of most popular (highest number of registered customers) ones
4. Create a short write up on how you would plan to scale this component to be able to process in-memory billions of customers and millions of cuisines (Book-That-Table is already planning for galactic scale). (100 words max)

## Submitting your solution

+ Fork it to a **[!]**private**[!]** gitlab repository.
+ Put write up mentioned in point 4. into this file.
+ Share the project with gitlab user *quandoo_recruitment_task*
+ Send us an **ssh** clone link to the repository.